////////////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------------------//
//CODE BY: J. MATTHEW VANDEVANDER                                                         //
//Released as open source, you can steal or do whatever you want with this, I'd like to   //
//see what you can use if for though. :)                                                  //
//----------------------------------------------------------------------------------------//
////////////////////////////////////////////////////////////////////////////////////////////



function maxat(num, target) {
   if (target > num ) return num; else return target;
}
function minat(num, target) {
   if (target < num ) return num; else return target;
}


function button(x,y,title,func,w,h,color)
{
  if(!this.parent)
  {
    this.parent=screen
  }

  if (color) {
     this.upcolor = color;
     this.overcolor = CreateColor(maxat(255,color.red+100),maxat(255,color.green+100),maxat(255,color.blue+100),255);
     this.downcolor = CreateColor(minat(0,color.red-100),minat(0,color.green-100),minat(0,color.blue-100),255);
  }
  else {
     this.upcolor = button_upcolor;
     this.overcolor = button_overcolor;
     this.downcolor = button_downcolor;

  }

  container.call(this)
  this.title = title;
  this.screenx=x;
  this.screeny=y;
  this.x=this.screenx+this.parent.activearea.x
  this.y=this.screeny+this.parent.activearea.y
  if(w)
  {
    this.w=w;
  }
  else
  {
    this.w=systemfont_white.getStringWidth(title)+8;
  }
  if(h)
  {
    this.h=h;
  }
  else
  {
    this.h=systemfont_white.getHeight()+8;
  }
  this.func=func;
  this.edgecolor = white;
  this.ismouseover=false;
}

button.prototype = new container();
button.prototype.update = function()
{
  with (this)
  {
    x=screenx+parent.activearea.x
    y=screeny+parent.activearea.y
    if(screenx+w<parent.activearea.w&&screeny+h<parent.activearea.h)
    {
      if(parent.ismouseoveranyobject||!parent.focus)
      {
        ismouseover=false;ispressed=false;isactivated=false;
      }
      else
      {
        checkmouseover();
        checkmouseclicked();
        if(isactivated)
        {
          this.func();
        }
        if(!mouse.l)
        {
          ispressed=false; isactivated=false;
        }
      }
    }
  }
}

button.prototype.draw = function()
{
  with (this)
  {
    if(screenx+w<parent.activearea.w&&screeny+h<parent.activearea.h)
    {
      Rectangle(x,y,w,h,edgecolor)
      if(ispressed&&ismouseover)
      {
        Rectangle(x+2,y+2,w-4,h-4,this.downcolor)
      }
      else if(ismouseover)
      {
        Rectangle(x+2,y+2,w-4,h-4,this.overcolor)
      }
      else
      {
        Rectangle(x+2,y+2,w-4,h-4,this.upcolor)
      }
      {
      }
      text(x+4,y+4,title);
    }
    else
    {
      text(x,y,'ERROR: Button: "'+title+'" goes outside of Window: "'+parent.title+'" bounds. \nIn order to fix this problem, resize the window or move/resize the button.')
    }
  }
}

