////////////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------------------//
//CODE BY: J. MATTHEW VANDEVANDER                                                         //
//Released as open source, you can steal or do whatever you want with this, I'd like to   //
//see what you can use if for though. :)                                                  //
//----------------------------------------------------------------------------------------//
////////////////////////////////////////////////////////////////////////////////////////////

RequireScript("button.js")
RequireScript("slider.js")
RequireScript("checkbox.js")
RequireScript("isover.js")

function window(x,y,w,h,title,resizeable)
{
  container.call(this)
  if(w<40)
  {
    w=40;
  }
  this.x = x;
  this.y = y;
  this.w = w+4;
  this.h = h+22;
  this.title = title;
  if(resizeable){this.resizeable = resizeable;}else{this.resizeable=true;}
  this.titlelength = systemfont_white.getStringWidth(this.title)
  this.ismouseoveranyobject = false;
  this.objects = new Array();
  this.titlebar = new container();
  this.titlebar.x=this.x+2;
  this.titlebar.y=this.y+2;
  this.titlebar.w=this.w-22;
  this.titlebar.h=20;
  this.topedge = new container();
  this.topedge.x=this.x
  this.topedge.y=this.y
  this.topedge.w=this.w
  this.topedge.h=2
  this.bottomedge = new container();
  this.bottomedge.x=this.x
  this.bottomedge.y=this.y+this.h-2
  this.bottomedge.w=this.w
  this.bottomedge.h=2
  this.leftedge = new container();
  this.leftedge.x=this.x
  this.leftedge.y=this.y
  this.leftedge.w=2
  this.leftedge.h=this.h
  this.rightedge = new container();
  this.rightedge.x=this.x+this.w-2
  this.rightedge.y=this.y
  this.rightedge.w=2
  this.rightedge.h=this.h
  this.closebutton = new container();
  this.closebutton.x=this.x+this.w-18;
  this.closebutton.y=this.y+2;
  this.closebutton.w=16;
  this.closebutton.h=16;
  this.activearea = new function()
  {
  }
  this.activearea.x=this.x+2;
  this.activearea.y=this.y+this.titlebar.h;
  this.activearea.w=w;
  this.activearea.h=h;
  this.grabbed=false;
  this.pickedup=false;
  this.stretchingfromtop=false;
  this.stretchingfrombottom=false;
  this.stretchingfromleft=false;
  this.stretchingfromright=false;
  this.resizing=false;
  this.inith=this.h
  this.inity=this.y
  this.clickedx=0;
  this.clickedy=0;
  this.killme=false;
}

window.prototype = new container();
window.prototype.update = function()
{
  with (this)
  {
    if(!parent.focusedwindow)
    {
      parent.focusedwindow=this;
    }
        if(parent.focusedwindow==this||ismouseover)
    {
      focus=true;
    }
    else{focus=false;}
    if(parent.ismouseoveranywindow||parent.ismouseoveranyobject)
    {
      focus=false;
      ismouseover=false; 
      titlebar.ismouseover=false;
      closebutton.ismouseover=false;
      topedge.ismouseover=false;
      bottomedge.ismouseover=false;
      leftedge.ismouseover=false;
      rightedge.ismouseover=false;
      updatecontents();
    }
    else 
    {
      if(grabbed==true&&Math.abs(mouse.x-(x+clickedx))>5||grabbed==true&&Math.abs(mouse.y-(y+clickedy))>5)
      {
        pickedup=true;
      }
      if(pickedup&&!resizing)
      {
        x=mouse.x-clickedx;y=mouse.y-clickedy
      }
      if(stretchingfromtop){if(mouse.y<inity+inith-24){y=mouse.y;h=inith-(mouse.y-inity);}else{y=inity+inith-24; h=24}}
      if(stretchingfrombottom){h=mouse.y-y}
      if(stretchingfromleft){if(mouse.x<initx+initw-(26+titlelength)){x=mouse.x;w=initw-(mouse.x-initx);}else{x=initx+initw-(26+titlelength); w=26+titlelength;}}
      if(stretchingfromright){w=mouse.x-x}
      if(!resizing){
      closebutton.checkmouseover();
      closebutton.checkmouseclicked();
      }
      updatecontents();
      checkmouseover();
      titlebar.checkmouseover();
      if(resizeable)
      {
      topedge.checkmouseover();
      bottomedge.checkmouseover();
      leftedge.checkmouseover();
      rightedge.checkmouseover();
      }
      if(mouse.l&&!mouse.lheld&&ismouseover)
      {
        parent.focusedwindow=this;
      }
      if(closebutton.isactivated)
      {
        this.killme=true;
      }
      if(mouse.l&&!mouse.lheld&&titlebar.ismouseover&&grabbed==false)
      {
        grabbed=true; clickedx=mouse.x-x;clickedy=mouse.y-y
      }
      if(mouse.l&&!mouse.lheld&&topedge.ismouseover&&!stretchingfromtop)
      {
        stretchingfromtop=true; inith=h;inity=y; resizing=true;
      }
      if(mouse.l&&!mouse.lheld&&bottomedge.ismouseover&&!stretchingfrombottom)
      {
        stretchingfrombottom=true; resizing=true;
      }
      if(mouse.l&&!mouse.lheld&&leftedge.ismouseover&&!stretchingfromright)
      {
        stretchingfromleft=true; initw=w; initx=x; resizing=true;
      }
      if(mouse.l&&!mouse.lheld&&rightedge.ismouseover&&!stretchingfromleft)
      {
        stretchingfromright=true; resizing=true;
      }
            if(!mouse.l)
      {
        resizing=false; stretchingfromtop=false; stretchingfrombottom=false; stretchingfromleft=false; stretchingfromright=false; grabbed=false; pickedup=false; clickedx=0; clickedy=0; closebutton.ispressed=false; closebutton.isactivated=false; titlebar.ispressed=false; titlebar.isactivated=false;
      }
    }
  }
}

window.prototype.draw = function()
{
  with (this)
  {
    if(swshadowson)
    {
      for(var loop=0;loop<12;loop++)
      {
        Rectangle(x+.02*(loop*loop),y+.02*(loop*loop),w+2+.02*(loop*loop),h+2+.02*(loop*loop),window_shadowcolor)
      }
    }
    Rectangle(x,y,w,h,window_edgecolor);
    if(titlebar.ismouseover){Rectangle(titlebar.x,titlebar.y,titlebar.w,titlebar.h-4,window_titlebar_overcolor);}
    else
    {Rectangle(titlebar.x,titlebar.y,titlebar.w,titlebar.h-4,window_titlebar_color);}
    if(closebutton.ismouseover&&!closebutton.ispressed)
    {Rectangle(closebutton.x,closebutton.y,closebutton.w,closebutton.h,window_closebutton_overcolor);}
    else if(closebutton.ispressed&&closebutton.ismouseover)
    {Rectangle(closebutton.x,closebutton.y,closebutton.w,closebutton.h,window_closebutton_downcolor);}
    else
    {Rectangle(closebutton.x,closebutton.y,closebutton.w,closebutton.h,window_closebutton_upcolor);}
    Rectangle(activearea.x,activearea.y,activearea.w,activearea.h,window_fillcolor);
    text(titlebar.x+2,titlebar.y+2,title);
    if(topedge.ismouseover&&!resizing||stretchingfromtop||stretchingfromleft&&stretchingfromtop||stretchingfromright&&stretchingfromtop){Rectangle(topedge.x,topedge.y,topedge.w,topedge.h,window_edgehighlightcolor)}
    if(leftedge.ismouseover&&!resizing||stretchingfromleft||stretchingfromleft&&stretchingfromtop||stretchingfromleft&&stretchingfrombottom){Rectangle(leftedge.x,leftedge.y,leftedge.w,leftedge.h,window_edgehighlightcolor)}
    if(rightedge.ismouseover&&!resizing||stretchingfromright||stretchingfromright&&stretchingfromtop||stretchingfromright&&stretchingfrombottom){Rectangle(rightedge.x,rightedge.y,rightedge.w,rightedge.h,window_edgehighlightcolor)}
    if(bottomedge.ismouseover&&!resizing||stretchingfrombottom||stretchingfrombottom&&stretchingfromleft||stretchingfrombottom&&stretchingfromright){Rectangle(bottomedge.x,bottomedge.y,bottomedge.w,bottomedge.h,window_edgehighlightcolor)}
    drawcontents();
    if(ismouseover&&parent.focusedwindow!=this)
    {Rectangle(x,y,w,h,window_highlightercolor);}
    else if(parent.focusedwindow!=this)
    {Rectangle(x,y,w,h,window_darkenercolor);}
    
  }
}

window.prototype.updatecontents = function()
{
  with (this)
  {
    if(h<24){h=24;}
    if(w<26+titlelength){w=26+titlelength;}
    titlebar.x=x+2
    titlebar.y=y+2
    titlebar.w=w-22
    titlebar.h=20
    topedge.x=x
    topedge.y=y
    topedge.w=w
    topedge.h=2
    bottomedge.x=x
    bottomedge.y=y+h-2
    bottomedge.w=w
    bottomedge.h=2
    leftedge.x=x
    leftedge.y=y
    leftedge.w=2
    leftedge.h=h
    rightedge.x=x+w-2
    rightedge.y=y
    rightedge.w=2
    rightedge.h=h
    activearea.x=x+2
    activearea.y=y+titlebar.h
    activearea.w=w-4
    activearea.h=h-22
    closebutton.x=x+w-18;
    closebutton.y=y+2;
    closebutton.w=16;
    closebutton.h=16;
          if (objects.length)
      {
        ismouseoveranyobject = false;
        var z = 0
        do
        {
          objects[z].update();
          if(objects[z].ismouseover==true)
          {
            ismouseoveranyobject=true;
          }
          z++
        }
        while(z<objects.length);
      }
  }
}

window.prototype.drawcontents = function()
{
  with (this)
  {
    if (objects.length)
    {
      var z = objects.length - 1
      do
      {
        objects[z].draw();
        z--
      }
      while(z>=0);
    }
  }
}

window.prototype.add = function(thingtoadd)
{
  thingtoadd.parent=this;
  thingtoadd.x=thingtoadd.screenx+this.activearea.x
  thingtoadd.y=thingtoadd.screeny+this.activearea.y
  this.objects[this.objects.length] = thingtoadd
}
